diff --git a/virEvent.cs b/virEvent.cs
new file mode 100644
index 0000000..7aacfc2
--- /dev/null
+++ b/virEvent.cs
@@ -0,0 +1,32 @@
+﻿/*
+ * Copyright (C)
+ *   Arnaud Champion <arnaud.champion@devatom.fr>
+ *   Jaromír Červenka <cervajz@cervajz.com>
+ *
+ * See COPYING.LIB for the License of this software
+ */
+
+using System.Runtime.InteropServices;
+
+namespace LibvirtBindings
+{
+    public class virEvent
+    {
+        ///<summary>
+        /// Function to install callbacks
+        ///</summary>
+        ///<param name="addHandle">the virEventAddHandleFunc which will be called (a delegate)</param>
+        ///<param name="updateHandle">the virEventUpdateHandleFunc which will be called (a delegate)</param>
+        ///<param name="removeHandle">the virEventRemoveHandleFunc which will be called (a delegate)</param>
+        ///<param name="addTimeout">the virEventAddTimeoutFunc which will be called (a delegate)</param>
+        ///<param name="updateTimeout">the virEventUpdateTimeoutFunc which will be called (a delegate)</param>
+        ///<param name="removeTimeout">the virEventRemoveTimeoutFunc which will be called (a delegate)</param>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virEventRegisterImpl")]
+        public static extern void RegisterImpl([MarshalAs(UnmanagedType.FunctionPtr)]virEventAddHandleFunc addHandle,
+                                               [MarshalAs(UnmanagedType.FunctionPtr)]virEventUpdateHandleFunc updateHandle,
+                                               [MarshalAs(UnmanagedType.FunctionPtr)]virEventRemoveHandleFunc removeHandle,
+                                               [MarshalAs(UnmanagedType.FunctionPtr)]virEventAddTimeoutFunc addTimeout,
+                                               [MarshalAs(UnmanagedType.FunctionPtr)]virEventUpdateTimeoutFunc updateTimeout,
+                                               [MarshalAs(UnmanagedType.FunctionPtr)]virEventRemoveTimeoutFunc removeTimeout);
+    }
+}
diff --git a/virInterface.cs b/virInterface.cs
new file mode 100644
index 0000000..1902023
--- /dev/null
+++ b/virInterface.cs
@@ -0,0 +1,39 @@
+﻿/*
+ * Copyright (C)
+ *   Arnaud Champion <arnaud.champion@devatom.fr>
+ *   Jaromír Červenka <cervajz@cervajz.com>
+ *
+ * See COPYING.LIB for the License of this software
+ */
+
+namespace LibvirtBindings
+{
+    public class virInterface
+    {
+        // TODO virInterfaceCreate
+
+        // TODO virInterfaceDefineXML
+
+        // TODO virInterfaceDestroy
+
+        // TODO virInterfaceFree
+
+        // TODO virInterfaceGetConnect
+
+        // TODO virInterfaceGetMACString
+
+        // TODO virInterfaceGetName
+
+        // TODO virInterfaceGetXMLDesc
+
+        // TODO virInterfaceIsActive
+
+        // TODO virInterfaceLookupByMACString
+
+        // TODO virInterfaceLookupByName
+
+        // TODO virInterfaceRef
+
+        // TODO virInterfaceUndefine
+    }
+}
diff --git a/virLibrary.cs b/virLibrary.cs
new file mode 100644
index 0000000..465dc98
--- /dev/null
+++ b/virLibrary.cs
@@ -0,0 +1,44 @@
+﻿/*
+ * Copyright (C)
+ *   Arnaud Champion <arnaud.champion@devatom.fr>
+ *   Jaromír Červenka <cervajz@cervajz.com>
+ *
+ * See COPYING.LIB for the License of this software
+ */
+
+using System.Runtime.InteropServices;
+
+namespace LibvirtBindings
+{
+    public class virLibrary
+    {
+        /// <summary>
+        /// Provides two information back, @libVer is the version of the library while @typeVer will be the version of the hypervisor 
+        /// type @type against which the library was compiled. If @type is NULL, "Xen" is assumed, 
+        /// if @type is unknown or not available, an error code will be returned and @typeVer will be 0.
+        /// </summary>
+        /// <param name="libVer">
+        /// A <see cref="System.UInt64"/>return value for the library version (OUT).
+        /// </param>
+        /// <param name="type">
+        /// A <see cref="System.String"/>the type of connection/driver looked at.
+        /// </param>
+        /// <param name="typeVer">
+        /// A <see cref="System.UInt64"/>return value for the version of the hypervisor (OUT).
+        /// </param>
+        /// <returns>
+        /// -1 in case of failure, 0 otherwise, and values for @libVer and @typeVer have the format major * 1,000,000 + minor * 1,000 + release.
+        /// </returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virGetVersion")]
+        public static extern int GetVersion([Out] out ulong libVer, [In] string type, [Out] out ulong typeVer);
+        /// <summary>
+        /// Initialize the library. It's better to call this routine at startup in multithreaded applications to avoid 
+        /// potential race when initializing the library.
+        /// </summary>
+        /// <returns>
+        /// 0 in case of success, -1 in case of error.
+        /// </returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virInitialize")]
+        public static extern int Initialize();
+    }
+}
diff --git a/virNetwork.cs b/virNetwork.cs
new file mode 100644
index 0000000..96ac5db
--- /dev/null
+++ b/virNetwork.cs
@@ -0,0 +1,179 @@
+﻿/*
+ * Copyright (C)
+ *   Arnaud Champion <arnaud.champion@devatom.fr>
+ *   Jaromír Červenka <cervajz@cervajz.com>
+ *
+ * See COPYING.LIB for the License of this software
+ */
+
+using System;
+using System.Runtime.InteropServices;
+
+namespace LibvirtBindings
+{
+    public class virNetwork
+    {
+        /// <summary>
+        /// Increment the reference count on the network. For each additional call to this method, 
+        /// there shall be a corresponding call to virNetworkFree to release the reference count, 
+        /// once the caller no longer needs the reference to this object. 
+        /// This method is typically useful for applications where multiple threads are using a connection, 
+        /// and it is required that the connection remain open until all threads have finished using it. ie, 
+        /// each new thread using a network would increment the reference count.
+        /// </summary>
+        /// <param name="network">
+        /// A <see cref="IntPtr"/>the network to hold a reference on.
+        /// </param>
+        /// <returns>
+        /// 0 in case of success, -1 in case of failure.
+        /// </returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNetworkRef")]
+        public static extern int Ref(IntPtr network);
+
+        // TODO virNetworkSetAutostart
+
+        // TODO virNetworkUndefine
+        /// <summary>
+        /// Create and start a defined network. If the call succeed the network moves from the defined to the running networks pools.
+        /// </summary>
+        /// <param name="network">pointer to a defined network</param>
+        /// <returns>0 in case of success, -1 in case of error</returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNetworkCreate")]
+        public static extern int Create(IntPtr network);
+        /// <summary>
+        /// Create and start a new virtual network, based on an XML description similar to the one returned by virNetworkGetXMLDesc()
+        /// </summary>
+        /// <param name="conn">pointer to the hypervisor connection</param>
+        /// <param name="xmlDesc">an XML description of the network</param>
+        /// <returns>a new network object or NULL in case of failure</returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNetworkCreateXML")]
+        public static extern IntPtr CreateXML(IntPtr conn, string xmlDesc);
+        /// <summary>
+        /// Define a network, but does not create it
+        /// </summary>
+        /// <param name="conn">pointer to the hypervisor connection</param>
+        /// <param name="xmlDesc">the XML description for the network, preferably in UTF-8</param>
+        /// <returns>NULL in case of error, a pointer to the network otherwise</returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNetworkDefineXML")]
+        public static extern IntPtr DefineXML(IntPtr conn, string xmlDesc);
+        /// <summary>
+        /// Destroy the network object. The running instance is shutdown if not down already and all resources used by it are given back to the hypervisor. This does not free the associated virNetworkPtr object. This function may require privileged access
+        /// </summary>
+        /// <param name="network">a network object</param>
+        /// <returns>0 in case of success and -1 in case of failure.</returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNetworkDestroy")]
+        public static extern int Destroy(IntPtr network);
+        /// <summary>
+        /// Free the network object. The running instance is kept alive. The data structure is freed and should not be used thereafter.
+        /// </summary>
+        /// <param name="network">a network object</param>
+        /// <returns>0 in case of success and -1 in case of failure</returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNetworkFree")]
+        public static extern int Free(IntPtr network);
+        /// <summary>
+        /// Provides a boolean value indicating whether the network configured to be automatically started when the host machine boots.
+        /// </summary>
+        /// <param name="network">a network object</param>
+        /// <param name="autostart">the value returned</param>
+        /// <returns>-1 in case of error, 0 in case of success</returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNetworkGetAutostart")]
+        public static extern int GetAutostart(IntPtr network, int autostart);
+        /// <summary>
+        /// Provides a bridge interface name to which a domain may connect a network interface in order to join the network.
+        /// </summary>
+        /// <param name="network">a network object</param>
+        /// <returns>a 0 terminated interface name, or NULL in case of error. the caller must free() the returned value</returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNetworkGetBridgeName")]
+        [return: MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(StringWithoutNativeCleanUpMarshaler))]
+        public static extern string GetBridgeName(IntPtr network);
+        /// <summary>
+        /// Provides the connection pointer associated with a network. The reference counter on the connection is not increased by this call. WARNING: When writing libvirt bindings in other languages, do not use this function. Instead, store the connection and the network object together
+        /// </summary>
+        /// <param name="network">pointer to a network</param>
+        /// <returns>the virConnectPtr or NULL in case of failure</returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNetworkGetConnect")]
+        public static extern IntPtr GetConnect(IntPtr network);
+        /// <summary>
+        /// Get the public name for that network
+        /// </summary>
+        /// <param name="network">a network object</param>
+        /// <returns>a pointer to the name or NULL, the string need not be deallocated its lifetime will be the same as the network object</returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNetworkGetName")]
+        [return: MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(StringWithoutNativeCleanUpMarshaler))]
+        public static extern string GetName(IntPtr network);
+        /// <summary>
+        /// Get the UUID for a network as string
+        /// </summary>
+        /// <param name="network">a network object</param>
+        /// <param name="uuid">string of the uuid</param>
+        /// <returns>-1 in case of error, 0 in case of success</returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNetworkGetUUIDString")]
+        private static extern int GetUUIDString(IntPtr network, [Out] char[] uuid);
+
+        ///<summary>
+        /// Get the UUID for a network as string
+        ///</summary>
+        ///<param name="network">a network object, a netowrk IntPtr</param>
+        ///<returns>string of the uuid</returns>
+        public static string virNetworkGetUUIDString(IntPtr network)
+        {
+            char[] uuidArray = new char[36];
+            GetUUIDString(network, uuidArray);
+            return new string(uuidArray);
+        }
+        /// <summary>
+        /// Provide an XML description of the network. The description may be reused later to relaunch the network with virNetworkCreateXML().
+        /// </summary>
+        /// <param name="network">a network object</param>
+        /// <param name="flags">an OR'ed set of extraction flags, not used yet</param>
+        /// <returns>a 0 terminated UTF-8 encoded XML instance, or NULL in case of error. the caller must free() the returned value</returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNetworkGetXMLDesc")]
+        [return: MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(StringWithoutNativeCleanUpMarshaler))]
+        public static extern string GetXMLDesc(IntPtr network, int flags);
+        /// <summary>
+        /// Determine if the network is currently running
+        /// </summary>
+        /// <param name="network">pointer to the network object</param>
+        /// <returns>1 if running, 0 if inactive, -1 on error</returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNetworkIsActive")]
+        public static extern int IsActive(IntPtr network);
+        /// <summary>
+        /// Determine if the network has a persistent configuration which means it will still exist after shutting down
+        /// </summary>
+        /// <param name="network">pointer to the network object</param>
+        /// <returns>x1 if persistent, 0 if transient, -1 on error</returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNetworkIsPersistent")]
+        public static extern int IsPersistent(IntPtr network);
+        /// <summary>
+        /// Try to lookup a network on the given hypervisor based on its name.
+        /// </summary>
+        /// <param name="conn">pointer to the hypervisor connection</param>
+        /// <param name="name">name for the network</param>
+        /// <returns>a new network object or NULL in case of failure. If the network cannot be found, then VIR_ERR_NO_NETWORK error is raised</returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNetworkLookupByName")]
+        public static extern IntPtr LookupByName(IntPtr conn, string name);
+        /// <summary>
+        /// Try to lookup a network on the given hypervisor based on its UUID
+        /// </summary>
+        /// <param name="conn">pointer to the hypervisor connection</param>
+        /// <param name="uuidstr">the string UUID for the network</param>
+        /// <returns>a new network object or NULL in case of failure. If the network cannot be found, then VIR_ERR_NO_NETWORK error is raised</returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNetworkLookupByUUIDString")]
+        public static extern IntPtr LookupByUUIDString(IntPtr conn, string uuidstr);
+        /// <summary>
+        /// Configure the network to be automatically started when the host machine boots
+        /// </summary>
+        /// <param name="network">a network object</param>
+        /// <param name="autostart">whether the network should be automatically started 0 or 1</param>
+        /// <returns>-1 in case of error, 0 in case of success</returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNetworkSetAutostart")]
+        public static extern int SetAutostart(IntPtr network, int autostart);
+        /// <summary>
+        /// Undefine a network but does not stop it if it is running
+        /// </summary>
+        /// <param name="network">pointer to a defined network</param>
+        /// <returns>0 in case of success, -1 in case of error</returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNetworkUndefine")]
+        public static extern int Undefine(IntPtr network);
+    }
+}
diff --git a/virNode.cs b/virNode.cs
new file mode 100644
index 0000000..a4198dd
--- /dev/null
+++ b/virNode.cs
@@ -0,0 +1,163 @@
+﻿/*
+ * Copyright (C)
+ *   Arnaud Champion <arnaud.champion@devatom.fr>
+ *   Jaromír Červenka <cervajz@cervajz.com>
+ *
+ * See COPYING.LIB for the License of this software
+ */
+
+using System;
+using System.Runtime.InteropServices;
+
+namespace LibvirtBindings
+{
+    public class virNode
+    {
+		private const int MaxStringLength = 1024;
+		
+        // TODO virNodeDeviceCreateXML
+
+        // TODO virNodeDeviceDestroy
+
+        // TODO virNodeDeviceDettach
+
+        // TODO virNodeDeviceFree
+
+        // TODO virNodeDeviceGetName
+
+        // TODO virNodeDeviceGetParent
+
+        /// <summary>
+        /// Fetch an XML document describing all aspects of the device.
+        /// </summary>
+        /// <param name="dev">pointer to the node device</param>
+        /// <param name="flags">flags for XML generation (unused, pass 0)</param>
+        /// <returns>the XML document, or NULL on error</returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNodeDeviceGetXMLDesc")]
+        [return: MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(StringWithoutNativeCleanUpMarshaler))]
+        public static extern string DeviceGetXMLDesc(IntPtr dev, uint flags);
+
+        // TODO virNodeDeviceListCaps
+
+        /// <summary>
+        /// Lookup a node device by its name.
+        /// </summary>
+        /// <param name="conn">pointer to the hypervisor connection</param>
+        /// <param name="name">unique device name</param>
+        /// <returns>a virNodeDevicePtr if found, NULL otherwise.</returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNodeDeviceLookupByName")]
+        public static extern IntPtr DeviceLookupByName(IntPtr conn, string name);
+        // TODO virNodeDeviceNumOfCaps
+
+        // TODO virNodeDeviceReAttach
+
+        // TODO virNodeDeviceRef
+
+        // TODO virNodeDeviceReset
+
+        // TODO virNodeGetCellsFreeMemory
+
+        /// <summary>
+        /// Provides the free memory available on the Node Note: most libvirt APIs provide memory sizes in kilobytes, 
+        /// but in this function the returned value is in bytes. Divide by 1024 as necessary.
+        /// </summary>
+        /// <param name="conn">
+        /// A <see cref="IntPtr"/>pointer to the hypervisor connection.
+        /// </param>
+        /// <returns>
+        /// The available free memory in bytes or 0 in case of error.
+        /// </returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNodeGetFreeMemory")]
+        public static extern ulong GetFreeMemory(IntPtr conn);
+        /// <summary>
+        /// Extract hardware information about the node.
+        /// </summary>
+        /// <param name="h">
+        /// A <see cref="IntPtr"/>pointer to the hypervisor connection.
+        /// </param>
+        /// <param name="info">
+        /// Pointer to a virNodeInfo structure allocated by the user.
+        /// </param>
+        /// <returns>
+        /// 0 in case of success and -1 in case of failure.
+        /// </returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNodeGetInfo")]
+        public static extern int GetInfo(IntPtr h, [Out] virNodeInfo info);
+
+        // TODO virNodeGetSecurityModel
+
+        /// <summary>
+        /// Collect the list of node devices, and store their names in @names.
+        /// If the optional 'cap' argument is non-NULL, then the count will be restricted to devices with the specified capability.
+        /// </summary>
+        /// <param name="conn">
+        /// A <see cref="IntPtr"/>pointer to the hypervisor connection.
+        /// </param>
+        /// <param name="cap">
+        /// Capability name.
+        /// </param>
+        /// <param name="names">
+        /// Array to collect the list of node device names.
+        /// </param>
+        /// <param name="maxnames">
+        /// Size of @names.
+        /// </param>
+        /// <param name="flags">
+        /// Flags (unused, pass 0).
+        /// </param>
+        /// <returns>
+        /// The number of node devices found or -1 in case of error.
+        /// </returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNodeListDevices")]
+        public static extern int ListDevices(IntPtr conn, string cap, IntPtr names, int maxnames, uint flags);
+        /// <summary>
+        /// Collect the list of node devices, and store their names in @names.
+        /// If the optional 'cap' argument is non-NULL, then the count will be restricted to devices with the specified capability.
+        /// </summary>
+        /// <param name="conn">
+        /// A <see cref="IntPtr"/>pointer to the hypervisor connection.
+        /// </param>
+        /// <param name="cap">
+        /// Capability name.
+        /// </param>
+        /// <param name="names">
+        /// Array to collect the list of node device names.
+        /// </param>
+        /// <param name="maxnames">
+        /// Size of @names.
+        /// </param>
+        /// <param name="flags">
+        /// Flags (unused, pass 0).
+        /// </param>
+        /// <returns>
+        /// The number of node devices found or -1 in case of error.
+        /// </returns>
+        public static int virNodeListDevices(IntPtr conn, string cap, ref string[] names, int maxnames, uint flags)
+        {
+            IntPtr namesPtr = Marshal.AllocHGlobal(MaxStringLength);
+            int count = ListDevices(conn, cap, namesPtr, maxnames, 0);
+            if (count > 0)
+                names = MarshalHelper.ptrToStringArray(namesPtr, count);
+            Marshal.FreeHGlobal(namesPtr);
+            return count;
+        }
+        /// <summary>
+        /// Provides the number of node devices. If the optional 'cap' argument is non-NULL, 
+        /// then the count will be restricted to devices with the specified capability.
+        /// </summary>
+        /// <param name="conn">
+        /// A <see cref="IntPtr"/>pointer to the hypervisor connection.
+        /// </param>
+        /// <param name="cap">
+        /// A <see cref="System.String"/>capability name.
+        /// </param>
+        /// <param name="flags">
+        /// A <see cref="System.UInt32"/>flags (unused, pass 0).
+        /// </param>
+        /// <returns>
+        /// The number of node devices or -1 in case of error.
+        /// </returns>
+        [DllImport("libvirt-0.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "virNodeNumOfDevices")]
+        public static extern int NumOfDevices(IntPtr conn, string cap, uint flags);
+    }
+}
diff --git a/virSecret.cs b/virSecret.cs
new file mode 100644
index 0000000..fd3a2c6
--- /dev/null
+++ b/virSecret.cs
@@ -0,0 +1,43 @@
+﻿/*
+ * Copyright (C)
+ *   Arnaud Champion <arnaud.champion@devatom.fr>
+ *   Jaromír Červenka <cervajz@cervajz.com>
+ *
+ * See COPYING.LIB for the License of this software
+ */
+
+namespace LibvirtBindings
+{
+    public class virSecret
+    {
+        // TODO virSecretDefineXML
+
+        // TODO virSecretFree
+
+        // TODO virSecretGetConnect
+
+        // TODO virSecretGetUUID
+
+        // TODO virSecretGetUUIDString
+
+        // TODO virSecretGetUsageID
+
+        // TODO virSecretGetUsageType
+
+        // TODO virSecretGetValue
+
+        // TODO virSecretGetXMLDesc
+
+        // TODO virSecretLookupByUUID
+
+        // TODO virSecretLookupByUUIDString
+
+        // TODO virSecretLookupByUsage
+
+        // TODO virSecretRef
+
+        // TODO virSecretSetValue
+
+        // TODO virSecretUndefine
+    }
+}
